/*
 * Copyright(C) OASIS(R) 2005,2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 */
package org.oasisopen.sdo.helper.util;

import javax.xml.transform.Source;

/**
 * The SchemaInputResolver is used to customise how the schema lookup is done.
 * When resolving an XML schema, the resolution is done in the following order:
 * <li>Attempt to resolve the schema using the SchemaInputResolver passed as a 
 * parameter to the define call.</li>
 * <li>Attempt to resolve the schema using the SchemaInputResolver passed as a 
 * parameter when the HelperContext was created.</li>
 * <li>Attempt to resolve the schema using the System ID.
 */
public abstract class SchemaInputResolver {

    /**
     * @param parentXSD - The system ID of the XSD doing the import or included (null for root schemas).
     * @param namespaceURI - The namespace portion of the import/include
     * @param systemID - The URI representing the location of the XML schema.
     * @return the resolved schema or null
     */
  public abstract Source resolveSchema(String parentXSD, String namespaceURI, String systemID);

}